package me.arcodeskel.uwpmcutils.commands;

import me.arcodeskel.uwpmcutils.Main;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.util.Vector;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Objects;

public class tpbuild implements Listener, CommandExecutor, Maps {

    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
        if (sender instanceof Player) {
            Player p = (Player) sender;
            activeCommands.add(p.getPlayer());
            p.setWalkSpeed(0);
            frozenPlayers.add(p.getPlayer());
            originalVelocity.put(p.getPlayer(), p.getVelocity().length());
            p.setVelocity(new Vector(0, -1.0, 0));
            String statement = "SELECT rank FROM rank WHERE username='" + p.getName() + "'";
            try (Connection connection = DatabaseConnection.getConnection()) {
                PreparedStatement preparedStatement = connection.prepareStatement(statement);
                if (!preparedStatement.executeQuery().getString("rank").contains("builder")) {
                    p.sendMessage("You do not have permission to execute this command.");
                    activeCommands.remove(p.getPlayer());
                    frozenPlayers.remove(p.getPlayer());
                    double velocity = originalVelocity.get(p.getPlayer());
                    p.getPlayer().setVelocity(p.getPlayer().getLocation().getDirection().multiply(velocity));
                    originalVelocity.remove(p.getPlayer());
                    p.setWalkSpeed(0.2F);
                }
                preparedStatement.close();
            } catch (SQLException e) {
                throw new RuntimeException(e);
            }

            if (activeCommands.contains(p.getPlayer())) {
                p.sendMessage(ChatColor.YELLOW + "Warping to builder in 10 seconds... Sneak to cancel teleportation request (shift)");
            }


            new BukkitRunnable() {
                @Override
                public void run() {

                    if (Objects.requireNonNull(p.getPlayer()).isSneaking() && !activeCommands.contains(p.getPlayer())) {
                        cancel();
                    }
                    // Check if the player is sneaking
                    if (Objects.requireNonNull(p.getPlayer()).isSneaking() && activeCommands.contains(p.getPlayer())) {
                        p.getPlayer().sendMessage(ChatColor.RED + "Command execution canceled because you are sneaking!");
                        double velocity = originalVelocity.get(p.getPlayer());
                        p.getPlayer().setVelocity(p.getPlayer().getLocation().getDirection().multiply(velocity));
                        frozenPlayers.remove(p.getPlayer());
                        originalVelocity.remove(p.getPlayer());
                        sneakingPlayers.remove(p.getPlayer());
                        p.getPlayer().setWalkSpeed(0.2F);
                        activeCommands.remove(p.getPlayer()); // Clean up
                        cancel(); // Stop the runnable
                    }
                }
            }.runTaskTimer(JavaPlugin.getPlugin(Main.class), 0, 1); // Check every tick

            new BukkitRunnable() {
                @Override
                public void run() {

                    if (!activeCommands.contains(p.getPlayer())) {
                        cancel();
                        return;
                    }

                    Location location = new Location(Bukkit.getWorld("builder"), 0, -60, 0);
                    p.teleport(location);
                    p.sendMessage(ChatColor.GREEN + "Sent to builder");
                    p.setWalkSpeed(0.2F);
                    double velocity = originalVelocity.get(p.getPlayer());
                    p.getPlayer().setVelocity(p.getPlayer().getLocation().getDirection().multiply(velocity));
                    p.setWalkSpeed(0.2F);
                    frozenPlayers.remove(p.getPlayer());
                    originalVelocity.remove(p.getPlayer());
                    activeCommands.remove(p.getPlayer());
                }
            }.runTaskLater(JavaPlugin.getPlugin(Main.class), 200);

        }
        return true;
    }
}
